
#include <windows.h>
#include <stdio.h>
#include <vfw.h>
#include <math.h>
#include <commctrl.h>  
#include <dshow.h> 
#pragma include_alias( "dxtrans.h", "qedit.h" )
#define __IDxtCompositor_INTERFACE_DEFINED__
#define __IDxtAlphaSetter_INTERFACE_DEFINED__
#define __IDxtJpeg_INTERFACE_DEFINED__
#define __IDxtKey_INTERFACE_DEFINED__
#include <qedit.h>  
#include <atlbase.h>  
#include "usbdxdll.h"

#define		BITMAP_WIDTH_MAX	640
#define		BITMAP_HEIGHT_MAX	480
#define		BMP_MAX_SIZE	(BITMAP_WIDTH_MAX*BITMAP_HEIGHT_MAX*3)


typedef	struct {
		BITMAPFILEHEADER	head;
		BITMAPINFOHEADER	vfmt;
		BYTE				bf[BMP_MAX_SIZE+64];		// bitmap table
	} BMAP_FILE,*PBMAP_FILE;

//int		APIENTRY PreUsbGo(HWND,long) ;
//int		APIENTRY PreUsbEnd(void) ;
//long	APIENTRY GetUsbDevice(HWND); 
//BOOL	APIENTRY SetEventWnd (int,HWND);
//BOOL	APIENTRY SetEventGo (int);

//*************************************
//*		W[GA`
//*************************************

extern		HDRAWDIB			hdrawdibDc;

	int					m_cmpchg[12];
	BITMAPINFOHEADER	m_chg_bmp[12];
	IMoniker				*m_pMoniker[20];
	int		m_CapOcx;		// 0: DirectX Error
	int		m_PreUsbGo=0;
//	ICreateDevEnum			*m_pDevEnum;
//	ISampleGrabber			*m_pGrab;
	IGraphBuilder			*m_pGraph;
	IBaseFilter				*m_pSrc;
	ICaptureGraphBuilder2	*m_pBuilder;
	IMediaControl			*m_pMediaControl;
	int						m_BmpInf_Sw;
	LONG					m_Bmp_Width;
	LONG					m_Bmp_Height;
	LONG					m_Bmp_comp;
	long					m_bitfmt;
	long					m_comptype;
	long					m_getfram;
	void	MyDeleteMediaType(AM_MEDIA_TYPE *);
	void	MyFreeMediaType(AM_MEDIA_TYPE *);
	long	BmpFmt_Chk (long ,long ,long);
	long	BmpFmt_WidthSet(long);
	long	BmpFmt_HightSet(long);
	long	BmpFmt_CompSet(long);
	CRITICAL_SECTION	Capture_Critical[12];
	CRITICAL_SECTION	Que_Critical;
	CRITICAL_SECTION	Chk_Critical;
	CRITICAL_SECTION	Tim_Critical;
	CRITICAL_SECTION	Ans_Critical;
	HANDLE	m_cap_event;			// 
	long	m_capture_exe;
	long	m_capture_sw;
	long	m_InitCaputure_sw;
	long	m_safemode;
	int		usbmaxken;
	int		m_usbken=0;
	int		m_usberr;
	int		m_usbflg[12];
	long	m_capexe[12];
	HWND	m_hWndC[12];
	PBYTE	m_vbuf[12];
	long	m_vbln[12];
	long	m_capln[12];
	BITMAPINFOHEADER	m_cap_bmp[12];
	SYSTEMTIME  m_GetDay[12];
	PBYTE	m_capbuf;
	PBYTE	m_rgbbuf;
	HWND	m_CapWnd;
	HWND	hWndCnv;
	void	usbcapture (long);
	struct {
		int		msg;
		int		fmt;
		int		typ;
		int		fram;
	} m_que[20];
	int		m_wrtquepos;
	int		m_getquepos;
	IPin *GetPin(IBaseFilter *,PIN_DIRECTION);
	HANDLE		m_ans_event;			// 
	HANDLE		m_chk_event;			// start
	HANDLE		m_stp_event;			// sttop
	HANDLE		m_end_event;			// end

	HANDLE		mt_ans_event;			// 
	HANDLE		mt_str_event;			// start
	HANDLE		mt_stp_event;			// stop
	HANDLE		mt_end_event;			// end

	struct {
		int		no;			//	1=>6
		int		typ;		//  0:   1 :disp  2 :ok
		int		rtcd;
	} m_ans[20];
	int		m_wrtanspos;
	int		m_getanspos;

	int 	UsbChk_Thread  (LPVOID);
	int 	Timer_Thread  (LPVOID);
	int		Exec_Check (long,long);
	long	GetUsbMoniker(void) ;
	void	OnCaptureGo(int,int,int,int);
	void	OnCaptureOk (int,int);
	void	UsbCapStart(void);
	void	UsbCapEnd (void);
	
//*************************************
//*		GA`
//*************************************
//static		int					dbgmode = 0;
//static		HANDLE				dbgfile;
//static		void				dbgput(char*);

static		PBYTE				cap_vbuf;
static		PBYTE				cap_rgbf;
static		int					cap_cnt;
static		int					cap_sw;
static		long				cap_len;
//static		HANDLE				cap_event;
static		HWND				cap_wnd;
static		BITMAPINFOHEADER	cap_bmp;
static		PBMAP_FILE			capwbf;

static		void	Video_Dsp (HWND,LPBITMAPINFOHEADER,long,PBYTE);
static		long	YuY2ToRgb (LPBITMAPINFOHEADER ,long ,PBYTE, LPBITMAPINFOHEADER,PBYTE);
static		void	Video_Dsp (HWND,LPBITMAPINFOHEADER,long,PBYTE);
static		void	YuvBitCnv (PBYTE,PBYTE,long,long);
static		int		Get_bmtfile (HWND,LPBITMAPINFOHEADER,PBYTE,DWORD,LPBYTE);

static		IMoniker			*Usb_pMoniker[20];
static		int					usbchkken;


static				HANDLE	UsbChk_Thread_inf;
static				DWORD	UsbChk_threadID;
static		HANDLE	Timer_Thread_inf;
static		DWORD	Timer_threadID;


static	struct {
	int		no;
	BYTE	unm[64];
} usb[10];


static	int		eventkn=0;
static	struct {
		int		no;
		HWND	hwnd1;
		HWND	hwnd2;
		HWND	hwnd3;
	} evnt_hwnd[10];



class SampleGrabberCallback : public ISampleGrabberCB
{
public:

    // QƃJEgɌB
    STDMETHODIMP_(ULONG) AddRef() { return 1; }
    STDMETHODIMP_(ULONG) Release() { return 2; }

    STDMETHODIMP QueryInterface(REFIID riid, void **ppvObject)
    {
        if (NULL == ppvObject) return E_POINTER;
        if (riid == __uuidof(IUnknown))
        {
            *ppvObject = static_cast<IUnknown*>(this);
             return S_OK;
        }
        if (riid == __uuidof(ISampleGrabberCB))
        {
            *ppvObject = static_cast<ISampleGrabberCB*>(this);
             return S_OK;
        }
      
		return E_NOTIMPL;
    }

    STDMETHODIMP SampleCB(double Time, IMediaSample *pSample)
    {
        return E_NOTIMPL;
    }

    STDMETHODIMP BufferCB(double Time, BYTE *pBuffer, long BufferLen)
    {
		if (!BufferLen) return E_FAIL;
		if (cap_cnt) {
			cap_cnt--;
			CopyMemory (cap_vbuf,pBuffer,BufferLen);
			cap_len	= BufferLen;
			cap_sw = 0;
            return S_OK;
		}
		if (cap_sw) return S_OK;
//************************************************************
#if 0
        HANDLE hf = CreateFile("D:\\Example.bmp", GENERIC_WRITE, 
        FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
        if (hf == INVALID_HANDLE_VALUE)
        {
            return E_FAIL;
        }
    //    long cbBitmapInfoSize = g_StillMediaType.cbFormat - SIZE_PREHEADER;
    //    VIDEOINFOHEADER *pVideoHeader =
    //       (VIDEOINFOHEADER*)g_StillMediaType.pbFormat;

        BITMAPFILEHEADER bfh;
        ZeroMemory(&bfh, sizeof(bfh));
        bfh.bfType = 'MB';  // "MB" ̃gGfBAB
        bfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
        bfh.bfSize = bfh.bfOffBits + BufferLen ;
        
        // t@C wb_[ށB
        DWORD dwWritten = 0;
        WriteFile( hf, &bfh, sizeof( bfh ), &dwWritten, NULL );
        WriteFile(hf, &cap_bmp, sizeof(BITMAPFILEHEADER), &dwWritten, NULL);        
        WriteFile( hf, pBuffer, BufferLen, &dwWritten, NULL );
        CloseHandle( hf );
#endif
//************************************************************

		SetEvent(m_cap_event);
		cap_sw = 1;
//		dbgput(" CAP OK");
        return S_OK;

    }

};

#if 0

static void dbgput(char* bf)
{
	char	wkbf[256];
	char	lrcf[5];
	DWORD	dwWritten;
	lrcf[0] = 0x0d;
	lrcf[1] = 0x0a;
	lrcf[2] = 0;

	if (dbgmode) {
		lstrcpy( wkbf,  bf);
		lstrcat (wkbf,  lrcf);
		WriteFile(dbgfile, &wkbf, lstrlen(wkbf), &dwWritten, NULL);
	}

	return;

}
#endif


void	UsbCapStart(void)
{

	HRESULT  hret;
	int		i;

//	dbgput( "UsbCapStart Jn");

	m_CapOcx	= 1;
	hret = CoInitialize(NULL);
	if (hret != S_OK) m_CapOcx = 0;
	m_PreUsbGo =	0;
	m_BmpInf_Sw	=	0;
	m_bitfmt	=	0;
	m_comptype	=	0;
	m_capture_sw	=	0;
	m_InitCaputure_sw	=	0;
	m_capture_exe	=	0;
	m_wrtquepos		=	0;
	m_getquepos		=	0;
	m_wrtanspos		=	0;
	m_getanspos	=		0;
	m_usbken		=	0;
	m_safemode		=	1;
	m_usberr		=	0;
	for (i=0;i<12;i++) {
		InitializeCriticalSection(&Capture_Critical[i]);
		m_usbflg[i] = 0;
		m_cmpchg[i] = 0;
	}
	InitializeCriticalSection(&Que_Critical);
	InitializeCriticalSection(&Chk_Critical);
	InitializeCriticalSection(&Tim_Critical);
	InitializeCriticalSection(&Ans_Critical);
	m_cap_event		=	CreateEvent(NULL,FALSE,FALSE,NULL);
	m_ans_event		=	CreateEvent(NULL,FALSE,FALSE,NULL);
	m_chk_event		=	CreateEvent(NULL,FALSE,FALSE,NULL);
	m_stp_event		=	CreateEvent(NULL,FALSE,FALSE,NULL);
	m_end_event		=	CreateEvent(NULL,FALSE,FALSE,NULL);

	mt_ans_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);
	mt_str_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);
	mt_stp_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);
	mt_end_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);

//	hdrawdibDc = DrawDibOpen();

}


void	UsbCapEnd (void)
{
	int		i;

	if (m_PreUsbGo) PreUsbEnd ();
	m_PreUsbGo	=	0;
	CloseHandle (m_cap_event);
	CloseHandle (m_ans_event);
	CloseHandle (m_chk_event);
	CloseHandle (m_stp_event);
	CloseHandle (m_end_event);

	CloseHandle (mt_ans_event);
	CloseHandle (mt_str_event);
	CloseHandle (mt_stp_event);
	CloseHandle (mt_end_event);

	for (i=0;i<12;i++) {
		DeleteCriticalSection(&Capture_Critical[i]);
	}
	DeleteCriticalSection(&Ans_Critical);
	DeleteCriticalSection(&Que_Critical);
	DeleteCriticalSection(&Chk_Critical);
	DeleteCriticalSection(&Tim_Critical);
	CoUninitialize();
//	dbgput("UsbCapEnd I");
//	DrawDibClose (hdrawdibDc);
}



BOOL APIENTRY SetEventWnd (int no,HWND hwnd1,HWND hwnd2,HWND hwnd3)
{

	if (eventkn >= 10) return FALSE;
	evnt_hwnd[eventkn].hwnd1=	hwnd1;
	evnt_hwnd[eventkn].hwnd2=	hwnd2;
	evnt_hwnd[eventkn].hwnd3=	hwnd3;
	evnt_hwnd[eventkn].no	=	no;
	eventkn++;
	return TRUE;
}

BOOL APIENTRY SetEventGo (int no,int typ)
{
	int		i;
	DWORD	pos;
	pos = MAKELONG(5,5);
	HWND	wnd;

	for (i=0;i<eventkn;i++) {
		if (evnt_hwnd[i].no == no){
			switch (typ) {
				case 0:
					wnd = evnt_hwnd[i].hwnd1;
					break;
				case 1:
					wnd = evnt_hwnd[i].hwnd2;
					break;
				case 2:
					wnd = evnt_hwnd[i].hwnd3;
					break;
				default:
					wnd = evnt_hwnd[i].hwnd1;
					break;
			}
			PostMessage (wnd,WM_LBUTTONDOWN,MK_LBUTTON,pos);
			Sleep(5);
			PostMessage (wnd,WM_LBUTTONUP,MK_LBUTTON,pos);
			return TRUE;
			break;
		}
	}
	return FALSE;
}

long APIENTRY ScrolBarGet (HWND hwnd)
{
	int	rt;

	rt = GetScrollPos   (hwnd,SB_CTL);
	return rt;
}

long APIENTRY ScrolBarPos (HWND hwnd,int val)
{
	int	rt;
	rt = SetScrollPos   (hwnd,SB_CTL,val,TRUE);
	return rt;
}

long APIENTRY ScrolBarRang (HWND hwnd,int min,int max)
{
	int	rt;
	rt = SetScrollRange (hwnd,SB_CTL,min,max,FALSE);
	return rt;
}


long  APIENTRY GetUsbName(int idx,LPBYTE pbf)
{

	int		i;
	for (i=0;i<m_usbken;i++){
		if (idx == usb[i].no) {
			lstrcpy ((LPSTR)pbf,(LPSTR) usb[i].unm);
			return lstrlen ((LPSTR) pbf);
		}
	}
	return 0;
}

int  APIENTRY DspComboChk (HWND wnd,LPSTR txt)
{
	int		kn;
	int		i;
	int		rt;
	BYTE	buf[64];

	kn = SendMessage (wnd,CB_GETCOUNT,0,0);
	if (!kn) {
		return 2;
	}
	for (i=0;i<kn;i++) {
		rt = SendMessage (wnd,CB_GETLBTEXT,i,(LPARAM) buf);
		if (lstrcmp((LPSTR)buf,txt) == 0) {
			rt = SendMessage (wnd,CB_SETCURSEL,i,0);
			return 0;
		}
	}
	return 1;
}


int  APIENTRY DspComboGet (HWND wnd,LPSTR txt)
{
	int		kn;
	int		i;
	int		rt;
	BYTE	buf[64];

	kn = SendMessage (wnd,CB_GETCOUNT,0,0);
	if (!kn) {
		return 0;
	}
	for (i=0;i<kn;i++) {
		rt = SendMessage (wnd,CB_GETLBTEXT,i,(LPARAM) buf);
		if (lstrcmp((LPSTR)buf,txt) == 0) {
			return i+1;
		}
	}
	return 0;
}


long  APIENTRY GetUsbDevice(void) 
{
	// TODO: ި߯  ނǉĂB
 	HRESULT  hret;

	IGraphBuilder	*pGraph;
	ICreateDevEnum	*pDevEnum;
	IEnumMoniker	*pClassEnum; 

	IMoniker		*pMoniker;
	IPropertyBag	*pPropBag;
	VARIANT 		varName;
	CComBSTR		dnm;
	TCHAR			chnm[1024];
	int				ln;
	int				i;
	int				cnt;


	// 1. tB^Ot쐬
	hret = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
					IID_IGraphBuilder, (void **)&pGraph);
	if (hret != S_OK) return 0;

	// 2. VXefoCX񋓎q쐬
	
	hret = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
			  IID_ICreateDevEnum, (void **)&pDevEnum);
	if (hret != S_OK) {
		pGraph->Release();
		return 0;
	}
	pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
	if (pClassEnum == NULL) {
		pDevEnum->Release();
		pGraph->Release();
		return 0;
	}
	//********
	cnt = 0;

	while (pClassEnum->Next (1,&pMoniker,NULL) == S_OK) {
		hret = pMoniker->BindToStorage (0,0,IID_IPropertyBag,(void**) &pPropBag);
		if (FAILED(hret)) {
			pMoniker->Release ();	
			continue;
		}
		VariantInit (&varName);
		hret = pPropBag->Read (L"FriendlyName", &varName, 0);
		if (SUCCEEDED(hret))	{
			m_pMoniker[cnt] = pMoniker;
			cnt++;
			m_usbken = cnt;
			dnm = varName.bstrVal;
			ln =(int) dnm.Length();
			chnm[0] = (char) (0x30 + cnt);
			chnm[1] = 0x20;
			chnm[2] = ':';
			chnm[3] = 0x20;
			for (i=0;i<ln;i++) {
				chnm[i+4] = (char) dnm[i];
			}
			chnm[i+4] = 0;
			usb[cnt-1].no =	cnt;
			lstrcpy ((LPSTR)usb[cnt-1].unm,chnm);
		}
		VariantClear(&varName); 
		pPropBag->Release();
//		pMoniker->Release();
	}

	pClassEnum->Release();
	pDevEnum->Release();
	pGraph->Release();

	return cnt;
}



int APIENTRY PreUsbGo(HWND hwnd, long devno) 
{
	// TODO: ި߯  ނǉĂB
	IEnumMoniker	*pClassEnum = NULL; 
	IMoniker		*pMoniker = NULL;
	IPropertyBag	*pPropBag = NULL;
	IVideoWindow	*pVidWin = NULL;
	IAMStreamConfig *pConfig = NULL;
	AM_MEDIA_TYPE	*pcmt = NULL;
	AM_MEDIA_TYPE	*pgmt = NULL;
	FILTER_STATE	fst;

 	HRESULT			hret;


	int				hit;
	int				rtcd;

	RECT			wrect;
//	int				usbkn;
	if (m_PreUsbGo) return  1;
	m_PreUsbGo	=	1;

	if (devno == 0) return 1;
	if (m_usbken ==0) return 1;

	if (devno > m_usbken) return 1; 

	m_usbken = GetUsbMoniker() ;
	rtcd = Exec_Check(devno-1,m_usbken);
	if (rtcd) return 1;
	m_pGraph	=	NULL;
	m_pSrc		=	NULL;
	m_pMediaControl	=	NULL;
	m_pBuilder		=	NULL;


	pMoniker =	m_pMoniker[devno-1];
    pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&m_pSrc);
	pMoniker = NULL;
	if(!m_pSrc) {
		return 2;
	}
// 2. tB^Ot쐬
	hret = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
					IID_IGraphBuilder, (void **)&m_pGraph);
	if (hret != S_OK) {
		m_pSrc->Release();
		m_pSrc	=	NULL;
		return 3;
	}
	hret = m_pGraph->AddFilter(m_pSrc, L"Video Capture");
	if (hret != S_OK) {
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		return 4;
	}
//********************************************
  // 3. Lv`r_̍쐬
  m_pBuilder = NULL;
  hret = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC,
			IID_ICaptureGraphBuilder2, (void **)&m_pBuilder);
  if (hret != S_OK) {
	m_pGraph->Release ();
	m_pSrc->Release();
	m_pSrc			=	NULL;
	m_pGraph		=	NULL;
	return 5;
  }    
  hret = m_pBuilder->SetFiltergraph(m_pGraph);
  if (hret != S_OK) {
	m_pGraph->Release ();
	m_pSrc->Release();
	m_pSrc			=	NULL;
	m_pGraph		=	NULL;
	return 6;
  }

	hit = 0;
	hret = m_pBuilder->FindInterface(
			 &PIN_CATEGORY_CAPTURE, // vr[ sB
			0,    // ׂẴfBA ^CvB
			m_pSrc, // Lv` tB^ւ̃|C^B
			IID_IAMStreamConfig, (void**)&pConfig);
	if (hret == S_OK) {
		int iCount = 0, iSize = 0;
		hret = pConfig->GetNumberOfCapabilities(&iCount, &iSize);


		// TCY𒲂ׁA\̂nƂmFB
		if (iSize == sizeof(VIDEO_STREAM_CONFIG_CAPS))	{
			// rfI\͍\̂gB
			for (int iFormat = 0; iFormat < iCount; iFormat++)   {
				VIDEO_STREAM_CONFIG_CAPS scc;
				hret = pConfig->GetStreamCaps(iFormat, &pcmt, (BYTE*)&scc);
				if (SUCCEEDED(hret))    {
					/* tH[}bg𒲂ׁAꍇɂĂ͎gB */
					VIDEOINFOHEADER *pVih = (VIDEOINFOHEADER*)pcmt->pbFormat;
					rtcd = BmpFmt_Chk (pVih->bmiHeader.biWidth,
									pVih->bmiHeader.biHeight,
									pVih->bmiHeader.biCompression);
					if (rtcd == 0) {
						rtcd = pConfig->SetFormat (pcmt);
						MyDeleteMediaType(pcmt);
						hit = 1;
						break;
					}
					MyDeleteMediaType(pcmt);
				}
			}
		}
		pConfig->GetFormat(&pgmt);
		VIDEOINFOHEADER *pVih = (VIDEOINFOHEADER*)pgmt->pbFormat;
		m_Bmp_Width		=	pVih->bmiHeader.biWidth;
		m_Bmp_Height	=	pVih->bmiHeader.biHeight;
		m_Bmp_comp		=	pVih->bmiHeader.biCompression;
		MyDeleteMediaType(pgmt);
		pConfig->Release ();
	}
	if (hit) {
		m_BmpInf_Sw	=	1;
	}
	else {
		m_pBuilder->Release ();
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pBuilder		=	NULL;
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		return 7;
	}

	// fBXvC
	hret = m_pBuilder->RenderStream( &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, m_pSrc, NULL, NULL );
	//   m_pBuilder->RenderStream( &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, m_pSrc, NULL, NULL);
	if (hret != S_OK) {
		m_pBuilder->Release ();
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pBuilder		=	NULL;
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		return 8;
	}
	if (hwnd) {
		::GetClientRect ((HWND)hwnd,&wrect);
		m_pGraph->QueryInterface(IID_IVideoWindow, (void **)&pVidWin);
		pVidWin->put_Owner ((OAHWND)hwnd);
		pVidWin->put_WindowStyle (WS_CHILD| WS_CLIPSIBLINGS);
		pVidWin->SetWindowPosition (0,0,wrect.right,wrect.bottom);
	 }  

// 5. Lv`Jn
	hret = m_pGraph->QueryInterface(IID_IMediaControl, (void **)&m_pMediaControl);
	if (hret != S_OK) {
		m_pBuilder->Release ();
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pBuilder		=	NULL;
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		return 9;
	}
	hret = m_pMediaControl->GetState (2000,(OAFilterState *)&fst);
	if (hret == E_FAIL) {
		m_pMediaControl->Release ();
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pBuilder		=	NULL;
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		m_pMediaControl	=	NULL;
		return 10;
	}
	if (fst != 0) {
		// Not Stopped
		m_pMediaControl->Release ();
		m_pGraph->Release ();
		m_pSrc->Release();
		m_pBuilder		=	NULL;
		m_pSrc			=	NULL;
		m_pGraph		=	NULL;
		m_pMediaControl	=	NULL;
		return 11;
	}
	hret = m_pMediaControl->Run();
	if (hret != S_OK) {
		hret = m_pMediaControl->GetState (2000,(OAFilterState *)&fst);
		if (hret != S_OK) {
			m_pMediaControl->Release ();
			m_pGraph->Release ();
			m_pSrc->Release();
			m_pBuilder		=	NULL;
			m_pSrc			=	NULL;
			m_pGraph		=	NULL;
			m_pMediaControl	=	NULL;
			return 12;
		}
		if (fst != 2) {
			// Not Running
			m_pMediaControl->Release ();
			m_pGraph->Release ();
			m_pSrc->Release();
			m_pBuilder		=	NULL;
			m_pSrc			=	NULL;
			m_pGraph		=	NULL;
			m_pMediaControl	=	NULL;
			return 13;
		}
	}


	return 0;
}

int APIENTRY PreUsbEnd() 
{
	// TODO: ި߯  ނǉĂB
	IVideoWindow	*pVidWin = NULL;

	IMoniker		*pMoniker = NULL;


	if (!m_PreUsbGo) return  1;
	m_PreUsbGo	=	0;
	m_BmpInf_Sw	=	0;

	if (m_pMediaControl) {
		m_pMediaControl->Stop ();
		m_pMediaControl->Release();
	}
	if (m_pGraph) {
		m_pGraph->QueryInterface(IID_IVideoWindow, (void **)&pVidWin);
		pVidWin->put_Visible (OAFALSE);
		pVidWin->put_Owner (NULL);
		pVidWin->Release ();
		m_pGraph->RemoveFilter(m_pSrc);
		m_pGraph->Release();
	}
	if (m_pBuilder)	m_pBuilder->Release();
	if (m_pSrc) m_pSrc->Release();

	m_pMediaControl	=	NULL;
	m_pBuilder		=	NULL;
	m_pSrc			=	NULL;
	m_pGraph		=	NULL;

//	for (i=0;i<m_usbken;i++) {
//		pMoniker = Usb_pMoniker[i];
//		if (pMoniker) pMoniker->Release ();
//		Usb_pMoniker[i] = 0;
//	}

	return 0;
}

long APIENTRY PreViewFmtSet(long BitFmt, long cmp) 
{
	// TODO: ި߯  ނǉĂB
	//  Bit Fmt = 1: 640*480
	//            2: 320*240
	//            3: 160*120
	// Comp     = 1: IYUV
	//            2: I420
	if (!m_BmpInf_Sw) {
		m_bitfmt	=	BitFmt;
		m_comptype	=	cmp;
		return 0;
	}

	return 1;
}


long APIENTRY GetPreBmpWidth() 
{
	if (m_BmpInf_Sw) {
		return	m_Bmp_Width;
	}

	return 0;
}


long APIENTRY GetPreBmpHight() 
{
	if (m_BmpInf_Sw) {
		return	m_Bmp_Height;
	}

	return 0;
}

long APIENTRY GetPreBmpComp() 
{
	if (m_BmpInf_Sw) {
		return	m_Bmp_comp;
	}


	return 0;
}


long APIENTRY SetSafeMode(long mode) 
{
	m_safemode = mode;
	return 0;
}

long APIENTRY DspFmtTyp(long usbno, long dispwnd) 
{

	TCHAR	wk[64];
	if (usbno >= m_usbken) return 0;
	wsprintf (wk,"%03d * %03d",m_chg_bmp[usbno].biWidth,m_chg_bmp[usbno].biHeight);
	SetWindowText ((HWND) dispwnd,wk);
	return 1;
}

long APIENTRY DspCmpTyp(long usbno, long dspwnd) 
{

	TCHAR	wk[64];
	TCHAR	bf[64];
	if (usbno >= m_usbken) return 0;
//	if 	(m_cmpchg[usbno]) {		//YUY2--> RGB
//		strcpy (wk,"RGB24");
//	} else {
		if (m_chg_bmp[usbno].biCompression == 0) {
			strcpy (wk,"RGB");
		} else {
			memcpy (bf,(void *) &m_chg_bmp[usbno].biCompression,4);
			wsprintf (wk,"%c%c%c%c",bf[0],bf[1],bf[2],bf[3]);
		}
//	}

	SetWindowText ((HWND) dspwnd,wk);

	return 1;
}

long APIENTRY DspGetSize(long usbno, long dspwnd) 
{

	TCHAR	wk[64];
	if (usbno >= m_usbken) return 0;

//	wsprintf (wk,"%06d Byte",m_vbln[usbno]);
	wsprintf (wk,"%06d Byte",m_capln[usbno]);
	SetWindowText ((HWND) dspwnd,wk);

	return 1;
}

long APIENTRY DspGetDay(long usbno, long dspwnd) 
{

	TCHAR	wk[64];
	if (usbno >= m_usbken) return 0;

	wsprintf (wk,"%04d/%02d/%02d %02d:%02d:%02d",
						m_GetDay[usbno].wYear, 
						m_GetDay[usbno].wMonth, 
						m_GetDay[usbno].wDay,
						m_GetDay[usbno].wHour, 
						m_GetDay[usbno].wMinute, 
						m_GetDay[usbno].wSecond);
	SetWindowText ((HWND) dspwnd,wk);

	return 1;
}


long APIENTRY InitCapture(long unitken) 
{
	// TODO: ި߯  ނǉĂB

		int		i;
//		if (dbgmode) {
//			dbgfile = CreateFile("D:\\usbdxdlldbg.txt", GENERIC_WRITE,
//				FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
//		}

//		dbgput("InitCapture Jn");
		if (m_InitCaputure_sw != 0) {
			return 1;
		}
		UsbCapStart();
		usbmaxken = (int) unitken;
		if (usbmaxken > 12) usbmaxken = 12;
		m_InitCaputure_sw	=	1;
		for (i=0;i<usbmaxken;i++) {
			m_vbuf[i]  = (LPBYTE) VirtualAlloc(
						NULL,
						MEMORY_ALLOC_SIZE,						// 1 Mbyte
						MEM_RESERVE | MEM_COMMIT,
						PAGE_READWRITE
					);
			m_pMoniker[i]=0;
		}
		m_capbuf = (LPBYTE) VirtualAlloc(
						NULL,
						MEMORY_ALLOC_SIZE,						// 1 Mbyte
						MEM_RESERVE | MEM_COMMIT,
						PAGE_READWRITE
					);
		m_rgbbuf = (LPBYTE) VirtualAlloc(
						NULL,
						MEMORY_ALLOC_SIZE,						// 1 Mbyte
						MEM_RESERVE | MEM_COMMIT,
						PAGE_READWRITE
					);
		capwbf	=	(PBMAP_FILE) m_rgbbuf;

	UsbChk_Thread_inf	=	CreateThread(
						(LPSECURITY_ATTRIBUTES) NULL,
						0,
						(LPTHREAD_START_ROUTINE) UsbChk_Thread,
						(LPVOID) NULL,
						0,
						&UsbChk_threadID
						);


	WaitForSingleObject  (m_ans_event,5000);

	Timer_Thread_inf	=	CreateThread(
						(LPSECURITY_ATTRIBUTES) NULL,
						0,
						(LPTHREAD_START_ROUTINE) Timer_Thread,
						(LPVOID) NULL,
						0,
						&Timer_threadID
						);


	WaitForSingleObject  (mt_ans_event,5000);

	return 0;
}

long APIENTRY EndCapture(void) 
{
	// TODO: ި߯  ނǉĂB

	int		i;

	if (m_InitCaputure_sw == 0) {
		return 1;
	}

	m_InitCaputure_sw	=	0;
	SetEvent (m_end_event);		// ICxgs
	WaitForSingleObject  (UsbChk_Thread_inf,2000);

	SetEvent (mt_end_event);		// ICxgs
	WaitForSingleObject  (Timer_Thread_inf,2000);

	for (i=0;i<usbmaxken;i++) {
		VirtualFree( m_vbuf[i],0,MEM_RELEASE );
		if (m_pMoniker[i]) m_pMoniker[i]->Release ();
		m_pMoniker[i]=0;
	}
	VirtualFree( m_capbuf,0,MEM_RELEASE );
	VirtualFree( m_rgbbuf,0,MEM_RELEASE );
	UsbCapEnd ();
//	if (dbgmode) {
//		dbgput("EndCapture I");
//		CloseHandle(dbgfile);
//	}
	return 0;
}

long APIENTRY CaptureStart(HWND hwnd,HWND cwnd) 
{
	// TODO: ި߯  ނǉĂB
	int		i;

	if (m_capture_sw) return 1;
	m_wrtquepos	=	0;
	m_getquepos	=	0;
	m_wrtanspos		=	0;
	m_getanspos		=	0;
	m_capture_sw	=	1;
	m_capture_exe	=	0;
	m_CapWnd = (HWND) hwnd;
	hWndCnv	=	cwnd;
	for (i=0;i<12;i++) {
		m_usbflg[i] = 0;
	}
	SetEvent (m_chk_event);			// chk start
	WaitForSingleObject  (m_ans_event,2000);

	SetEvent (mt_str_event);		// timer
	WaitForSingleObject  (mt_ans_event,2000);
	return 0;
}

long APIENTRY CaptureEnd(void) 
{
		SetEvent (m_stp_event);			// chk ICxgs
	WaitForSingleObject  (m_ans_event,2000);

	SetEvent (mt_stp_event);		// timer ICxgs
	WaitForSingleObject  (mt_ans_event,2000);

	m_wrtquepos		=	0;
	m_getquepos		=	0;
	m_wrtanspos		=	0;
	m_getanspos		=	0;
	m_capture_sw	=	0;
	return 0;
}

long APIENTRY CaptureGo(long unitno, long fmt, long comp,long fram) 
{
	// TODO: ި߯  ނǉĂB
	int			wpos;
	int			rpos;

	if (!m_capture_sw) return 1;

	if (unitno < 1 || unitno > 12) return 1;
	EnterCriticalSection(&Que_Critical);
	wpos = m_wrtquepos;
	rpos = m_getquepos;
	
	wpos++;
	wpos &= 0xf;
	if (wpos  == rpos) {
		LeaveCriticalSection(&Que_Critical);
		return 1; // over flow
	}

	m_que[m_wrtquepos].msg  = unitno-1;
	m_que[m_wrtquepos].fmt  = fmt; 
	m_que[m_wrtquepos].typ  = comp; 
	m_que[m_wrtquepos].fram  = fram;  // not use
	m_wrtquepos++;
	m_wrtquepos &= 0xf;
	LeaveCriticalSection(&Que_Critical);
	return 0;
}




long APIENTRY SetCapWind(long usbno, long hwnd) 
{
	if (usbno == 0) return 1;
	m_hWndC[usbno-1] = (HWND) hwnd;
	return 0;
}

long APIENTRY WriteBmp(long usbno, LPBYTE bmpfnm)
{
	// TODO: ި߯  ނǉĂB
	FILE					*outfile;					/* target file */
	BITMAPFILEHEADER		head;
//	LPBITMAPINFOHEADER		pbit;
	DWORD					size;

	if (usbno >= m_usbken) return 0;

	size = m_vbln[usbno]+sizeof(BITMAPINFOHEADER);
	memset ((void*)&head,0,sizeof(BITMAPFILEHEADER));
	head.bfType = 'MB';
	head.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	head.bfSize    = head.bfOffBits + m_vbln[usbno];
	
	outfile = fopen((LPSTR)bmpfnm, "wb");
	fwrite (&head,sizeof(BITMAPFILEHEADER),1,outfile);
//	if 	(m_cmpchg[usbno]) {		//YUY2--> RGB
//		fwrite ((void *) &m_chg_bmp[usbno],sizeof(BITMAPINFOHEADER),1,outfile);
//	} else {
		fwrite ((void *) &m_cap_bmp[usbno],sizeof(BITMAPINFOHEADER),1,outfile);
//	}
	fwrite (m_vbuf[usbno],size,1,outfile);
	fclose(outfile);
	return 0;
}

long APIENTRY AnsSet_Rtn(long unitno, long typ, long rtcd) 
{
	int			wpos;
	int			rpos;

	if (!m_capture_sw) return 1;

	if (unitno < 1 || unitno > 12) return 1;

	EnterCriticalSection(&Ans_Critical);
	wpos = m_wrtanspos;
	rpos = m_getanspos;
	LeaveCriticalSection(&Ans_Critical);
	wpos++;
	wpos &= 0xf;
	if (wpos  == rpos) {
		return 1; // over flow
	}

	EnterCriticalSection(&Ans_Critical);
	m_ans[m_wrtanspos].no  = unitno-1;
	m_ans[m_wrtanspos].typ  = typ; 
	m_ans[m_wrtanspos].rtcd  = rtcd; 

	m_wrtanspos++;
	m_wrtanspos &= 0xf;
	LeaveCriticalSection(&Ans_Critical);
	return 0;
}

long APIENTRY AnsGet_Rtn(LPBYTE pbf)
{
	int	rt;
	int	i;
	int	typ;
	int	rtcd;
	BYTE	wk[64];

	rt	=	0;
//	if (m_capture_exe == 1) {
		EnterCriticalSection(&Ans_Critical);
		if (m_wrtanspos != m_getanspos) {

			i	=	m_ans[m_getanspos].no ;
			typ	=	m_ans[m_getanspos].typ;
			rtcd	=	m_ans[m_getanspos].rtcd;
			wsprintf ((LPSTR)wk,"%01d,%01d,%01d",i+1,typ,rtcd);
			lstrcpy ((LPSTR) pbf,(LPSTR) wk);
			rt = lstrlen((LPSTR) wk);
			m_getanspos++;
			m_getanspos &= 0xf;
		}
		LeaveCriticalSection(&Ans_Critical);
//	}
	return rt;		
}


long APIENTRY AnsChk_Rtn(void)
{
	int	rt;

	rt =0;
	EnterCriticalSection(&Ans_Critical);
	if (m_wrtanspos != m_getanspos) rt = 1;
	LeaveCriticalSection(&Ans_Critical);
	return rt;
}

//:***********************************************************

long BmpFmt_Chk (long biWidth,long biHeight,long biCompression)
{

	//  m_bitfmt  = 1: 640*480
	//              2: 320*240
	//              3: 160*120

	// m_comptype = 1: IYUV
	//              2: I420
	//              3: RGB
	//				4:YUY2
	int		err;

	err = 1;
	if (m_bitfmt == 1) {
		if (biWidth == 640 && biHeight == 480) err = 0;
	}
	else if (m_bitfmt == 2) {
		if (biWidth == 320 && biHeight == 240) err = 0;
	}
	else if (m_bitfmt == 3) {
		if (biWidth ==  160 && biHeight == 120) err = 0;
	}
	if (err) {
		return 1;
	}

	err = 1;
//	if (m_comptype == 1 || m_comptype == 2) {
//		if (biCompression == 'VUYI') err = 0;
//		if (biCompression == '024I') err = 0;
//	}

	if (m_comptype == 1 && biCompression == 'VUYI') err = 0;
	if (m_comptype == 2 && biCompression == '024I') err = 0;
	if (m_comptype == 3 && biCompression == BI_RGB) err = 0;
	if (m_comptype == 4 && biCompression == '2YUY') err = 0;
	
	if (err) {
		return 2;
	}
	return 0;
}

long BmpFmt_WidthSet(long  bitfmt)
{
	if (bitfmt == 1) return  640;
	if (bitfmt == 2) return  320;
	if (bitfmt == 3) return  160;
	return		640;
}
long BmpFmt_HightSet(long  bitfmt)
{
	if (bitfmt == 1) return  480;
	if (bitfmt == 2) return  240;
	if (bitfmt == 3) return  120;
	return		480;
}
long BmpFmt_CompSet(long   comptype)
{
	if (comptype == 1) return  'VUYI';
	if (comptype == 2) return  '024I';
	if (comptype == 4) return  '2YUY';
	return		BI_RGB;
}










long GetUsbMoniker(void) 
{
	// TODO: ި߯  ނǉĂB
 	HRESULT  hret;

	IGraphBuilder	*pGraph;
	ICreateDevEnum	*pDevEnum;
	IEnumMoniker	*pClassEnum; 

	IMoniker		*pMoniker;
	IPropertyBag	*pPropBag;
	int				cnt;
	VARIANT 		varName;


	// 1. tB^Ot쐬
	hret = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
					IID_IGraphBuilder, (void **)&pGraph);
	if (hret != S_OK) return 0;

	// 2. VXefoCX񋓎q쐬
	
	hret = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
			  IID_ICreateDevEnum, (void **)&pDevEnum);
	if (hret != S_OK) return 1;
	pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pClassEnum, 0);

	//********
	cnt = 0;
	while (pClassEnum->Next (1,&pMoniker,NULL) == S_OK) {
		hret = pMoniker->BindToStorage (0,0,IID_IPropertyBag,(void**) &pPropBag);
		if (FAILED(hret)) {
			pMoniker->Release ();	
			continue;
		}
		VariantInit (&varName);
		hret = pPropBag->Read (L"FriendlyName", &varName, 0);
		if (SUCCEEDED(hret))	{
			Usb_pMoniker[cnt] = pMoniker;
			cnt++;
		}
		VariantClear(&varName); 
		pPropBag->Release();
	}
	pClassEnum->Release();
	pDevEnum->Release();
	pGraph->Release();
	return cnt;
}

void MyDeleteMediaType(AM_MEDIA_TYPE *pmt)
{
    if (pmt != NULL)
    {
        MyFreeMediaType(pmt); // ɂẮuFreeMediaTypevQƂ邱ƁB
//        CoTaskMemFree(pmt);
    }
}

void MyFreeMediaType(AM_MEDIA_TYPE *mt)
{
    if (mt->cbFormat != 0)
    {
        CoTaskMemFree((PVOID)mt->pbFormat);
        mt->cbFormat = 0;
        mt->pbFormat = NULL;
    }
    if (mt->pUnk != NULL)
    {
                // pUnk ͎gpȂ悢̂ŕsvAS߁B
        mt->pUnk->Release();
        mt->pUnk = NULL;
    }
}

int 	UsbChk_Thread  (LPVOID)
{
//    CCAPOCXDXCtrl* pObject = (CCAPOCXDXCtrl*)pParam; 
	HANDLE		hEvents[10];			// Cxg҂p
	int			hEventNum;			// Cxg҂p
	int			iRet;
	int			run_sw;
	DWORD		wait_type=INFINITE;
	long		ret;
	int			uno;
	HRESULT  hret;
	IMoniker		*pMoniker;
	int			i;

	run_sw	=	TRUE;
	SetEvent(m_ans_event);
	hret = CoInitialize(NULL);

	hEvents[0]	=	m_end_event;			// Iʒm
	hEvents[1]	=	m_chk_event;				// Jn
	hEvents[2]	=	m_stp_event;				// Jn
	hEventNum	=	3;
	while (run_sw) {
		iRet = WaitForMultipleObjects(hEventNum,hEvents,FALSE, wait_type);
		if(iRet == 0) {
			run_sw	=	FALSE;
			break;
		}
		else if (iRet == 1) {
			// usbchk Start
			SetEvent (m_ans_event);
			wait_type = 500;
			uno = 0;
			EnterCriticalSection(&Chk_Critical);
			usbchkken = GetUsbMoniker();
			m_usberr = 0;
			LeaveCriticalSection(&Chk_Critical);
		}
		else if (iRet == 2) {
			// stop
			SetEvent (m_ans_event);
			wait_type=INFINITE;
			for (i=0;i<usbchkken;i++) {
				pMoniker = Usb_pMoniker[i];
				if (pMoniker) pMoniker->Release ();
				Usb_pMoniker[i] = 0;
			}
		}
		else if (iRet == WAIT_TIMEOUT) {
			EnterCriticalSection(&Chk_Critical);
			EnterCriticalSection(&Tim_Critical);
			if (usbchkken)  {
				ret = Exec_Check (uno,usbchkken);
				m_usbflg[uno] = ret;
				uno++;
				if (uno >= m_usbken) uno = 0;
			}
			else {
				m_usbflg[uno] = 1;
			}
			LeaveCriticalSection(&Tim_Critical);
			LeaveCriticalSection(&Chk_Critical);
			wait_type = 500;
		}
	}
	CoUninitialize();
	return	TRUE;
}

int 	Timer_Thread  (LPVOID)
{
	HANDLE		hEvents[10];			// Cxg҂p
	int			hEventNum;			// Cxg҂p
	int			iRet;
	int			run_sw;
	UINT		i;

	DWORD		wait_type=INFINITE;
	int			fmt,typ,frm;
	HRESULT  hret;


	int		exesw;

	hret = CoInitialize(NULL);
	run_sw	=	TRUE;
	SetEvent(mt_ans_event);

	exesw	=	0;
	hEvents[0]	=	mt_end_event;;			// Iʒm
	hEvents[1]	=	mt_str_event;				// Jn
	hEvents[2]	=	mt_stp_event;				// Jn
	hEventNum	=	3;
	while (run_sw) {
		iRet = WaitForMultipleObjects(hEventNum,hEvents,FALSE, wait_type);
		if(iRet == 0) {
			run_sw	=	FALSE;
			break;
		} else if (iRet == 1) {
			// timer Start
			SetEvent (mt_ans_event);
			wait_type = 1000;			//  1b
		}
		else if (iRet == 2) {
			// stop
			SetEvent (mt_ans_event);
			wait_type=INFINITE;
		}
		else if (iRet == WAIT_TIMEOUT) {
			if (exesw) continue;
			if (AnsChk_Rtn()) continue; 	
			exesw	=	1;
			EnterCriticalSection(&Que_Critical);
			EnterCriticalSection(&Chk_Critical);
			EnterCriticalSection(&Tim_Critical);
	
			if (m_wrtquepos != m_getquepos) {
				if (m_capture_exe == 0) {

					i = m_que[m_getquepos].msg ;
	//				prm = m_que[m_getquepos].fmtcmp * 256 + m_que[m_getquepos].fmttyp ;
					fmt	=	m_que[m_getquepos].fmt;
					typ	=	m_que[m_getquepos].typ;
					frm	=	m_que[m_getquepos].fram;
					m_getquepos++;
					m_getquepos &= 0xf;

					m_capture_exe	=	1;
					AnsSet_Rtn (i+1,1,0);
					OnCaptureGo (i,fmt,typ,frm);
					m_capture_exe	=	0;
	//				PostMessage(WM_CAPTURE_DSP,i,prm); VB.NET ֒ʒm
				}
			}
			LeaveCriticalSection(&Tim_Critical);
			LeaveCriticalSection(&Chk_Critical);
			LeaveCriticalSection(&Que_Critical);
			exesw	=	0;
		}
	}
	CoUninitialize();
	return	TRUE;
}
void OnCaptureOk (int usbno,int flg)
{
		// VB.NET ֒ʒm


	if (usbno < 1) return;

	AnsSet_Rtn (usbno,2,flg);
}


void OnCaptureGo(int no,int fmt,int typ,int fram) 
{

	if (m_capture_sw) {

		m_capexe[no]	=	1;
		m_bitfmt		= fmt;		// `
		m_comptype		= typ;		//k
		m_getfram		= fram;		// t[
		if (m_getfram < 5)		m_getfram = 5;
		if (m_getfram > 100)	m_getfram = 100;
//		EnableWindow (m_CapWnd,FALSE);

		usbcapture (no);

//		EnableWindow (m_CapWnd,TRUE);
		m_capexe[no]		=	0;

	}
}


int Exec_Check (long uno,long ukn)
{
	IMoniker				*pMoniker	=	NULL;
	IBaseFilter				*pSrc		=	NULL;
	IGraphBuilder			*pGraph		=	NULL;
	ICaptureGraphBuilder2	*pBuilder	=	NULL;
	IMediaControl			*pMediaControl= NULL;
 	HRESULT			hret;
	FILTER_STATE	fst;

	if (!m_safemode) return 0;		// No Check
	pMoniker		=	NULL;
	pSrc			=	NULL;
	pGraph			=	NULL;
	pBuilder		=	NULL;
	pMediaControl	=	NULL;

	pMoniker =	Usb_pMoniker[uno];
	if (!pMoniker) return 1;
	pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&pSrc);
	if(!pSrc) {
		return 1;
	}
	hret = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
					IID_IGraphBuilder, (void **)&pGraph);
	if (hret != S_OK) {
		pSrc->Release();
		return 1;
	}
	hret = pGraph->AddFilter(pSrc, L"Video Capture");
	if (hret != S_OK) {
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}
	 hret = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC,
				IID_ICaptureGraphBuilder2, (void **)&pBuilder);
	if (hret != S_OK) {
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}    
	hret = pBuilder->SetFiltergraph(pGraph);
	if (hret != S_OK) {
		pBuilder->Release ();
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}
	hret = pBuilder->RenderStream( &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pSrc, NULL, NULL );
	//   pBuilder->RenderStream( &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pSrc, NULL, NULL);
	if (hret != S_OK) {
		pBuilder->Release ();
		pGraph->Release ();
		pSrc->Release();
		return 2;
	}
	hret = pGraph->QueryInterface(IID_IMediaControl, (void **)&pMediaControl);
	if (hret != S_OK) {
		pBuilder->Release ();
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}
	hret = pMediaControl->GetState (2000,(OAFilterState *)&fst);
	if (hret == E_FAIL) {
		pMediaControl->Release ();
		pBuilder->Release ();
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}
	if (fst != 0) {
		// Not Stopped
		pMediaControl->Release ();
		pBuilder->Release ();
		pGraph->Release ();
		pSrc->Release();
		return 1;
	}
	pMediaControl->Release ();
	pBuilder->Release ();
	pGraph->Release ();
	pSrc->Release();
	return  0;
}

void usbcapture(long usbno) 
{

	IGraphBuilder	*pGraph = NULL;
	ICreateDevEnum	*pDevEnum = NULL;
	IEnumMoniker	*pClassEnum = NULL; 
	IBaseFilter		*pSrc = NULL;
	ICaptureGraphBuilder2	*pBuilder = NULL;
	IMediaControl			*pMediaControl = NULL;
	IBaseFilter *pSG_Filter;
	ISampleGrabber *pSG;
	FILTER_STATE	fst;
 	HRESULT  hret;

	IMoniker *pMoniker = NULL;
	IPropertyBag	*pPropBag = NULL;

	CComBSTR	dnm;



	int			hit;
	IVideoWindow	*pVidWin;
	RECT			wrect;
	AM_MEDIA_TYPE	*pcmt = NULL;
	AM_MEDIA_TYPE	*pgmt = NULL;
	int				rtcd;
	int				iret;
	int				rtcode=0;
	int				waittime;
	long	bsize;

//	dbgput("usbcapture start");
	
	if (usbno >= m_usbken) {
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
//		dbgput("usbcapture err 1");
		return ; 
	}

	if (m_usbflg[usbno]) {
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
//		dbgput("usbcapture err 2");
		return ;
	}


	m_BmpInf_Sw = 0;
	EnterCriticalSection(&Capture_Critical[usbno]);
	EnterCriticalSection(&Chk_Critical);
	cap_wnd		=	m_hWndC[usbno];
	m_vbln[usbno]	= 0;
	cap_vbuf	=	m_capbuf;
	cap_rgbf	=	m_rgbbuf;
	cap_len		=	0;
	//	cap_cnt		=	10;
	cap_cnt		=	m_getfram;
//	usbken = GetUsbMoniker() ;
	pMoniker =	m_pMoniker[usbno];
    pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&pSrc);
	if (!pSrc) {
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 3");
		return ;
	}
	hret = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
					IID_IGraphBuilder, (void **)&pGraph);
	if (hret != S_OK) {
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 4");
		return ;
	}

//	hr = AddToRot(pGraph, &dwRegister);
	
	hret = pGraph->AddFilter(pSrc, L"Video Capture");
	if (hret != S_OK) {
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 5");
		return ;
	}

//********************************************
  // 3. Lv`r_̍쐬
  pBuilder = NULL;
  hret = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC,
      IID_ICaptureGraphBuilder2, (void **)&pBuilder);
  if (hret != S_OK) {
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 6");

		return ;
  }    
  hret = pBuilder->SetFiltergraph(pGraph);
  if (hret != S_OK) {
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 7");
		return ;
  }    


// IAMStreamConfig ɑ΂ďo̓s₢킹 (ł͎ĂȂ)B
	IAMStreamConfig *pConfig = NULL;

	hit = 0;
	hret = pBuilder->FindInterface(
			 &PIN_CATEGORY_CAPTURE, // vr[ sB
			0,    // ׂẴfBA ^CvB
			pSrc, // Lv` tB^ւ̃|C^B
			IID_IAMStreamConfig, (void**)&pConfig);
	if (hret == S_OK) {
		int iCount = 0, iSize = 0;
		hret = pConfig->GetNumberOfCapabilities(&iCount, &iSize);

		// TCY𒲂ׁA\̂nƂmFB
		if (iSize == sizeof(VIDEO_STREAM_CONFIG_CAPS))	{
			// rfI\͍\̂gB
			for (int iFormat = 0; iFormat < iCount; iFormat++)   {
				VIDEO_STREAM_CONFIG_CAPS scc;
				hret = pConfig->GetStreamCaps(iFormat, &pcmt, (BYTE*)&scc);
				if (SUCCEEDED(hret))    {
					/* tH[}bg𒲂ׁAꍇɂĂ͎gB */
					VIDEOINFOHEADER *pVih = (VIDEOINFOHEADER*)pcmt->pbFormat;
					rtcd = BmpFmt_Chk (pVih->bmiHeader.biWidth,
									pVih->bmiHeader.biHeight,
									pVih->bmiHeader.biCompression);
					if (rtcd == 0) {
						rtcd = pConfig->SetFormat (pcmt);
						MyDeleteMediaType(pcmt);
						hit = 1;
						break;
					}
					MyDeleteMediaType(pcmt);
				}
			}
		}
		pConfig->GetFormat(&pgmt);
		VIDEOINFOHEADER *pVih = (VIDEOINFOHEADER*)pgmt->pbFormat;
		m_Bmp_Width		=	pVih->bmiHeader.biWidth;
		m_Bmp_Height	=	pVih->bmiHeader.biHeight;
		m_Bmp_comp		=	pVih->bmiHeader.biCompression;
		cap_bmp			=	pVih->bmiHeader;
		MyDeleteMediaType(pgmt);
		pConfig->Release ();
	}
	if (hit) {
		m_BmpInf_Sw	=	1;
	}
	else {
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,2);
		OnCaptureOk(usbno+1,2);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
		return ;
	}
	m_cap_bmp[usbno] = cap_bmp;


	// 4.1.1 Tv Oo tB^OtɒǉB
//	IBaseFilter *pSG_Filter;
	hret = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER,
		IID_IBaseFilter, (void**)&pSG_Filter);
	if (hret != S_OK) {
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 8");
		return ;
	}    

	hret = pGraph->AddFilter(pSG_Filter, L"SampleGrab");
	if (hret != S_OK) {
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 9");
		return ;
	}    



	// 4.3 Tv Ooݒ肷B
//	ISampleGrabber *pSG;
	hret = pSG_Filter->QueryInterface(IID_ISampleGrabber, (void**)&pSG);
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 10");
		return ;
	}    
	hret = pSG->SetOneShot(FALSE);
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 11");
		return ;
	}    
	hret = pSG->SetBufferSamples(FALSE);
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 12");
		return ;
	}    

	// 4.4	0 = SampleCB R[obN \bhgB
	
	// NX̃O[o CX^XB
	SampleGrabberCallback g_StillCapCB;

	hret =pSG->SetCallback(&g_StillCapCB, 1); 
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 13");
		return ;
	}    
 

	// fBXvC
	hret =  pBuilder->RenderStream( &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pSrc, pSG_Filter, NULL );
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 14");
		return ;
	}    

	if (m_CapWnd) {
			GetClientRect (m_CapWnd,&wrect);
		hret = pGraph->QueryInterface(IID_IVideoWindow, (void **)&pVidWin);
		if (hret != S_OK) {
			pGraph->RemoveFilter(pSrc);
			pSG_Filter->Release ();
			pBuilder->Release ();	
			pGraph->Release ();
			pSrc->Release ();
//			PostMessage(WM_CAPTURE_OK,usbno+1,1);
			OnCaptureOk(usbno+1,1);
			LeaveCriticalSection(&Capture_Critical[usbno]);
			LeaveCriticalSection(&Chk_Critical);
//			dbgput("usbcapture err 15");
			return ;
		}    
	//	pVidWin->put_Visible(OATRUE);
		pVidWin->put_Visible(OAFALSE);
	//	pVidWin->put_Owner ((OAHWND)m_CapWnd);
		pVidWin->put_AutoShow(0);
		pVidWin->put_WindowStyle (WS_CHILD| WS_CLIPSIBLINGS);
		pVidWin->SetWindowPosition (0,0,wrect.right,wrect.bottom);

	 }  

// 5. Lv`Jn
  	hret = pGraph->QueryInterface(IID_IMediaControl, (void **)&pMediaControl);
	if (hret != S_OK) {
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release ();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 16");
		return ;
	}    

	hret = pMediaControl->GetState (2000,(OAFilterState *)&fst);
	if (hret == E_FAIL) {
		pMediaControl->Release ();
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 17");
		return ;
	}
	if (fst != 0) {
		// Not Stopped
		pMediaControl->Release ();
		pGraph->RemoveFilter(pSrc);
		pSG_Filter->Release ();
		pBuilder->Release ();	
		pGraph->Release ();
		pSrc->Release();
//		PostMessage(WM_CAPTURE_OK,usbno+1,1);
		OnCaptureOk(usbno+1,1);
		LeaveCriticalSection(&Capture_Critical[usbno]);
		LeaveCriticalSection(&Chk_Critical);
//		dbgput("usbcapture err 18");
		return ;
	}

	//cap_event = m_cap_event;
	hret = pMediaControl->Run();
	if (hret != S_OK) {
		hret = pMediaControl->GetState (2000,(OAFilterState *)&fst);
		if (hret == E_FAIL) {
			pMediaControl->Release ();
			pGraph->RemoveFilter(pSrc);
			pSG_Filter->Release ();
			pBuilder->Release ();	
			pGraph->Release ();
			pSrc->Release();
//			PostMessage(WM_CAPTURE_OK,usbno+1,1);
			OnCaptureOk(usbno+1,1);
			LeaveCriticalSection(&Capture_Critical[usbno]);
			LeaveCriticalSection(&Chk_Critical);
//			dbgput("usbcapture err 19");
			return ;
		}
		if (fst != 2) {
			// Not Running
			pMediaControl->Release ();
			pGraph->RemoveFilter(pSrc);
			pSG_Filter->Release ();
			pBuilder->Release ();	
			pGraph->Release ();
			pSrc->Release();
//			PostMessage(WM_CAPTURE_OK,usbno+1,1);
			OnCaptureOk(usbno+1,1);
			LeaveCriticalSection(&Capture_Critical[usbno]);
			LeaveCriticalSection(&Chk_Critical);
//			dbgput("usbcapture err 20");
			return ;
		}
	}
	//if (m_CapWnd) {
//	dbgput("usbcapture Wait Start");
	rtcode = 0;
	waittime = 5000 + m_getfram * 60;
//	cap_event = m_cap_event;
	iret = WaitForSingleObject  (m_cap_event,waittime);
	GetLocalTime (&m_GetDay[usbno]);
//		MessageBox(NULL,"********Click to stop.***********", "DirectShow", MB_OK);
	if (cap_len > 0) { 
//		dbgput("usbcapture CAP OK");
		m_cmpchg[usbno]		=	1;		//YUY2--> RGB
		m_chg_bmp[usbno]	=	cap_bmp;	
//		Video_Dsp (cap_wnd,&cap_bmp,cap_len,m_capbuf);
		bsize = Get_bmtfile (hWndCnv,&cap_bmp,m_capbuf,cap_len,(LPBYTE) &capwbf->vfmt);
		m_cap_bmp[usbno] = capwbf->vfmt;
		CopyMemory (m_vbuf[usbno],capwbf->bf,bsize);
		m_vbln[usbno]	= bsize;
		m_capln[usbno]	= cap_len;
//		CopyMemory (m_vbuf[usbno],m_capbuf,cap_len);
//		m_vbln[usbno]	= cap_len;

	}
	else {
//		dbgput("usbcapture CAP Size Zero");
		rtcode = 1;
	}

	if (iret == WAIT_TIMEOUT) {
//		dbgput("usbcapture CAP Time Over");
		rtcode = 1;
	}
// Sleep (10000);
//	  MessageBox("Click to stop.", "DirectShow", MB_OK);

    pMediaControl->Stop ();
	if (m_CapWnd) {
	//	pVidWin->put_Visible (OAFALSE);
	//	pVidWin->put_Owner (NULL);
		pVidWin->Release ();
	}
	pMediaControl->Release();

	pSrc->Release();
	pSG->SetCallback(NULL, 1); 
//	pNull->Release ();

	// ÍAYꂸɃfBA ^Cv邱ƁB
//	CoTaskMemFree(&g_StillMediaType);

//	RemoveFromRot(dwRegister);

	pSG_Filter->Release();
	pSG->Release();
	pGraph->RemoveFilter(pSrc);
	pBuilder->Release();
	pGraph->Release();
	pGraph = NULL;
//	PostMessage(WM_CAPTURE_OK,usbno+1,rtcode);
	OnCaptureOk(usbno+1,rtcode);
	LeaveCriticalSection(&Capture_Critical[usbno]);
	LeaveCriticalSection(&Chk_Critical);
//	dbgput("usbcapture end");
}

static	void	Video_Dsp (HWND dspwnd,LPBITMAPINFOHEADER vfmt,long size,PBYTE pbmp)
{

	HDC			hDC;
	RECT		wrect;

	GetClientRect (dspwnd,&wrect);
	hDC = ::GetDC (dspwnd);
	DrawDibDraw (hdrawdibDc,
					hDC,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) vfmt,
					pbmp,
					0,0,-1,-1,0);
	ReleaseDC (dspwnd,hDC);

	return;
}

static	int Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pfmt,PBYTE pt,DWORD ptln,LPBYTE buf)
{

	int					rtcd;
	DWORD				size;
//*****   work
	DWORD				ln;
	int					ncol;
    int                 sz;

//************ ͗p
	HDC					in_hDC;
	BITMAP				in_bm;
	HBITMAP				in_hbmp;

//************ p
	RECT				wrect;
	HDC					mem_hDC;
	HBITMAP				mem_hbmp;


//***********  bitmap aria
    LPBYTE				to_hbit;
	LPBITMAPINFOHEADER	to_bithed;
	LPRGBQUAD			to_bitcol;


	in_hDC		=	GetDC (hwnd);
//	GetClientRect	  (hwnd,&rect);
	wrect.right  = pfmt->biWidth ;
	wrect.bottom = pfmt->biHeight ;
	wrect.left = 0;
	wrect.top  = 0;
	in_hbmp		=	CreateCompatibleBitmap (in_hDC,wrect.right,wrect.bottom);
	GetObject  (in_hbmp,sizeof(BITMAP),(LPSTR)&in_bm);

	mem_hDC		=	CreateCompatibleDC(in_hDC);
	SetMapMode (mem_hDC,GetMapMode (in_hDC));

	mem_hbmp =  (HBITMAP) SelectObject  (mem_hDC,in_hbmp);

	DrawDibDraw (hdrawdibDc,
				mem_hDC,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) pfmt,
				pt,
				0,0,-1,-1,0);

	SelectObject  (mem_hDC,mem_hbmp);
	ncol = in_bm.bmPlanes * in_bm.bmBitsPixel;

	if  (ncol <= 1) {
		ncol = 1;
		sz  = 1;
    }
	else if (ncol <= 4 ) {
		ncol = 4;
		sz  = 16;
	}
	else if (ncol <= 8 ) {
		ncol = 8;
		sz  = 256;
	}
	else {
		ncol = 24;
		sz  = 1024;
	}

	memset (buf,0,sizeof(BITMAPINFOHEADER));
	to_bithed	=	(LPBITMAPINFOHEADER) buf;
	to_bitcol	=	(LPRGBQUAD) buf + sizeof(BITMAPINFOHEADER);
	if (ncol == 24) {
		ln	=	0;
		to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);
	}
	else {
		ln 		=	(sz * sizeof(RGBQUAD));
		(LPBYTE)to_hbit		= (LPBYTE)buf + sizeof(BITMAPINFOHEADER) + (sz * sizeof(RGBQUAD));
	}

	to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);

	to_bithed->biWidth	=	in_bm.bmWidth;
	to_bithed->biHeight	=	in_bm.bmHeight;

//	to_bithed->biPlanes	=	in_bm.bmPlanes;
	to_bithed->biPlanes	=	1;
//	to_bithed->biBitCount=	in_bm.bmBitsPixel;
	to_bithed->biBitCount=	ncol;
	to_bithed->biCompression =	BI_RGB;


  	rtcd = GetDIBits ( mem_hDC,in_hbmp,0,in_bm.bmHeight,
				to_hbit,
				(LPBITMAPINFO) to_bithed,
				DIB_RGB_COLORS);

	DeleteObject (in_hbmp);
	DeleteObject (mem_hbmp);
	DeleteDC	 (mem_hDC);
	ReleaseDC    (hwnd,in_hDC);
	size = to_bithed->biSizeImage + ln;
	return size;

}



